package com.fjhx.flow.controller.flow;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.fjhx.flow.entity.flow.dto.FlowDefinitionDto;
import com.fjhx.flow.entity.flow.po.FlowDefinition;
import com.fjhx.flow.service.flow.FlowDefinitionService;
import com.ruoyi.common.constant.DatasourceConstant;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 * 流程定义 前端控制器
 * </p>
 *
 * @author
 * @since 2023-03-15
 */
@DS(DatasourceConstant.BASE)
@RestController
@RequestMapping("/flowDefinition")
public class FlowDefinitionController {

    @Autowired
    private FlowDefinitionService flowDefinitionService;

    /**
     * 添加租户流程
     */
    @PostMapping("/add")
    public void add(@RequestBody FlowDefinition flowDefinition) {
        flowDefinitionService.add(flowDefinition);
    }

    /**
     * 添加租户流程版本
     */
    @PostMapping("/addVersion")
    public void addVersion(@RequestBody FlowDefinitionDto dto) {
        flowDefinitionService.addVersion(dto);
    }

    // public static void main(String[] args) throws NoSuchMethodException, InvocationTargetException, IllegalAccessException, InstantiationException {
    //     Method method = FlowDefinitionDto.class.getMethod("send");
    //     method.invoke(FlowDefinitionDto.class.newInstance());
    // }

    // public static void main(String[] args) {
    //     String skipExpress = "${admin == admin2}";
    //     HashMap<String, Object> map = new HashMap<>();
    //     map.put("admin", "ad");
    //     map.put("admin2", "ad");
    //     System.out.println(expressionParsing(skipExpress,map));
    // }
    //
    // public static Boolean expressionParsing(String skipExpress, Map<String, Object> map) {
    //     if (StringUtils.isBlank(skipExpress) && map.isEmpty()) {
    //         return false;
    //     }
    //     ExpressionParser parser = new SpelExpressionParser();
    //     StandardEvaluationContext context = new StandardEvaluationContext();
    //
    //     TemplateParserContext templateParserContext = new TemplateParserContext("${", "}");
    //     MapAccessor propertyAccessor = new MapAccessor();
    //     context.setVariables(map);
    //     context.setPropertyAccessors(Collections.singletonList(propertyAccessor));
    //
    //     SpelExpression expression = (SpelExpression) parser.parseExpression(skipExpress, templateParserContext);
    //     expression.setEvaluationContext(context);
    //     return Boolean.TRUE.equals(expression.getValue(map, boolean.class));
    // }


}
