package com.ruoyi.web.controller.common;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.fjhx.flow.core.FlowDelegate;
import com.ruoyi.system.domain.SysConfig;
import com.ruoyi.system.service.ISysConfigService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Slf4j
@Service
public class TestFlow extends FlowDelegate {

    @Autowired
    private ISysConfigService sysConfigService;

    @DS("iot")
    @Transactional
    @Override
    public Long start(Long flowId, JSONObject data) {

        long id = IdWorker.getId();

        System.err.println(flowId);
        System.err.println(data);
        System.err.println(id);

        List<SysConfig> list = sysConfigService.list();
        SysConfig sysConfig = new SysConfig();
        sysConfig.setRemark("备注");
        sysConfigService.save(sysConfig);

        return id;
    }

    @Override
    public void end() {
        log.error("默认结束方法");
    }

    public void testEnd() {
        log.error("测试结束方法");
    }

    public void type1() {
        log.error("type1");
    }

    public void type2() {
        log.error("type2");
    }

    public void type3() {
        log.error("type2");
    }

}
